#pragma once

#include <ReferenceCounter.h>
#include <Either.h> 

class Block;
class Noise;
class Game;

class BiomGenerator : public virtual Framework::ReferenceCounter
{
protected:
    double biomXMultiplier;
    double biomYMultiplier;
    double biomOutputMultiplier;
    double airXMultiplier;
    double airYMultiplier;
    double airOutputMultiplier;
    double airOutputAddition;

public:
    BiomGenerator( double biomXMultiplier, double biomYMultiplier, double biomOutputMultiplier, double airXMultiplier, double airYMultiplier, double airOutputMultiplier, double airOutputAddition );
    virtual Framework::Either<Block*, int> getBlock( Noise* zNoise, int x, int y, int z, Game* zGame ) = 0;
    double getBiomXMultiplier();
    double getBiomYMultiplier();
    double getBiomOutputMultiplier();
    double getAirLevelXMultiplier();
    double getAirLevelYMultiplier();
    double getAirLevelOutputMultiplier();
    double getAirLevelOutputAddition();
};